/**
 * 
 */
package ila;

import ila.signals.AlarmStatus;
import ila.signals.BlinkRequest;
import sim.IScheduler;
import sim.error.ISimulationErrorHandler;
import sim.generic.Tick;


/**
 * TODO: Write me!
 *
 * <br>
 * <br>
 * Copyright (c) 2010 RWTH Aachen. All rights reserved.
 *
 * @author  Arne Haber
 * @date	28.09.2010
 */
public class AlarmCheckImpl extends ila.gen.AAlarmCheck {

    private int timer = -1;
    
    private AlarmStatus lastAlarmStatus = AlarmStatus.OFF;
    
    private boolean lastEmmitedBR = false;
    
    private boolean changed = false;
    
    /**
     * Constructor for ila.AlarmCheckImpl
     * @param blinkIntervall
     */
    public AlarmCheckImpl(int blinkIntervall) {
        super(blinkIntervall);
    }
    
    

    /**
     * @see ila.gen.AAlarmEval#timeStep(ila.signals.AlarmStatus)
     */
    @Override
    protected void timeStep(AlarmStatus alarmStatusBuffer) {
        if (alarmStatusBuffer != null && lastAlarmStatus != alarmStatusBuffer) {
            lastAlarmStatus = alarmStatusBuffer;
            changed = true;
        }
        
        if (changed) {
            switch (lastAlarmStatus) {
                case OFF:
                    timer = -1;
                    sendBlinkRequest(BlinkRequest.INACTIVE);
                    break;
                case ON:
                    timer = getBlinkIntervall() + 2;
                    break;
                default:
                    break;
            }
            changed = false;
        }
        if (timer > 0) {
            timer--;                
            if (timer == 0) {
                timer = getBlinkIntervall();
                lastEmmitedBR = !lastEmmitedBR;
            } 
            
            if (lastEmmitedBR) {
                sendBlinkRequest(BlinkRequest.OFF);
            }
            else {
                sendBlinkRequest(BlinkRequest.ON);
            }
        }
    }



    /**
     * @see ila.gen.AAlarmCheck#setup(sim.IScheduler, sim.error.ISimulationErrorHandler)
     */
    @Override
    public void setup(IScheduler scheduler, ISimulationErrorHandler errorHandler) {
        super.setup(scheduler, errorHandler);
//        getBlinkRequest().send(Tick.<BlinkRequest> get());
        sendBlinkRequest(BlinkRequest.INACTIVE);
    }
}
