/**
 * 
 */
package ila;

import sim.IScheduler;
import sim.error.ISimulationErrorHandler;
import sim.generic.Tick;
import ila.signals.BlinkRequest;
import ila.signals.OnOffCmd;
import ila.signals.OnOffRequest;
import ila.signals.SwitchStatus;



/**
 * TODO: Write me!
 *
 * <br>
 * <br>
 * Copyright (c) 2010 RWTH Aachen. All rights reserved.
 *
 * @author  Arne Haber
 * @date	28.09.2010
 */
public class ArbiterImpl extends ila.gen.ALightCtrl_Arbiter {

	private SwitchStatus currentSwitchStatus = SwitchStatus.OFF;
	
	private OnOffRequest currentDoorRequest = OnOffRequest.OFF;
	
	private BlinkRequest currentBlinkRequest = BlinkRequest.INACTIVE;
	
	private boolean initialized = false;
	
	private BlinkRequest lastInterpretedBlinkRequest;

    /**
     * @see ila.gen.AInteriorLightEval#timeStep(ila.signals.SwitchStatus, ila.signals.BlinkRequest, ila.signals.OnOffRequest)
     */
    @Override
    protected void timeStep(SwitchStatus switchStatusBuffer, BlinkRequest blinkRequestBuffer,
            OnOffRequest onOffRequestBuffer) {
        boolean changed = false;
        if (switchStatusBuffer != null && switchStatusBuffer != currentSwitchStatus) {
            currentSwitchStatus = switchStatusBuffer;
            changed = true;
        }
        if (onOffRequestBuffer != null && onOffRequestBuffer != currentDoorRequest) {
            currentDoorRequest = onOffRequestBuffer;
            changed = true;
        }
        if (blinkRequestBuffer != null && blinkRequestBuffer != currentBlinkRequest) {
            currentBlinkRequest = blinkRequestBuffer;
            changed = true;
        }
        
        if (changed || !initialized) {
            initialized = true;
            switch (currentBlinkRequest) {
                case INACTIVE: // no alarm behavior
                    regularBehavior();
                    break;
                case OFF:
                    if (currentBlinkRequest != lastInterpretedBlinkRequest) {
                        sendOnOffCmd(OnOffCmd.OFF);
                        lastInterpretedBlinkRequest = currentBlinkRequest;
                    }
                    break;
                case ON:
                    if (currentBlinkRequest != lastInterpretedBlinkRequest) {                        
                        sendOnOffCmd(OnOffCmd.ON);
                        lastInterpretedBlinkRequest = currentBlinkRequest;
                    }
                    break;
                default:
                    break;
            }
        }
        
    }

    /**
     * TODO: Write me!
     */
    private void regularBehavior() {
        switch (currentSwitchStatus) {
            case DOOR_DEPENDENT:
                doorDependent();
                break;
            case OFF:
                sendOnOffCmd(OnOffCmd.OFF);
                break;
            case ON:
                sendOnOffCmd(OnOffCmd.ON);
                break;
            default:
                break;
        }
        
    }

    /**
     * TODO: Write me!
     */
    private void doorDependent() {
        switch (currentDoorRequest) {
            case OFF:
                sendOnOffCmd(OnOffCmd.OFF);
                break;
            case ON:
                sendOnOffCmd(OnOffCmd.ON);
                break;
            default:
                break;
        }
    }

    /**
     * @see ila.gen.ALightCtrl_Arbiter#setup(sim.IScheduler, sim.error.ISimulationErrorHandler)
     */
    @Override
    public void setup(IScheduler scheduler, ISimulationErrorHandler errorHandler) {
        super.setup(scheduler, errorHandler);
        getOnOffCmd().send(Tick.<OnOffCmd>get());
    }
}
