/**
 * 
 */
package ila;

import static ila.signals.OnOffRequest.OFF;
import static ila.signals.OnOffRequest.ON;
import static ila.signals.SwitchStatus.DOOR_DEPENDENT;
import ila.signals.DoorStatus;
import ila.signals.OnOffRequest;
import ila.signals.SwitchStatus;
import sim.IScheduler;
import sim.error.ISimulationErrorHandler;
import sim.generic.Tick;

/**
 * TODO: Write me! <br>
 * <br>
 * Copyright (c) 2010 RWTH Aachen. All rights reserved.
 * 
 * @author Arne Haber
 * @date 28.09.2010
 */
public class DoorEvalImpl extends ila.gen.ADoorEval {
    
    /**
     * Constructor for ila.DoorEvalImpl
     * 
     * @param fadeOutTime
     */
    public DoorEvalImpl(int fadeOutTime) {
        super(fadeOutTime);
    }

    private SwitchStatus currentSwitchState;
    private DoorStatus processedDoorState;
    
    private final int TIMER_INACTIVE = -1;
    private int timer = TIMER_INACTIVE;
    private boolean initialized = false;
    
    /**
     * @see ila.gen.ADoorEval#timeStep(ila.signals.DoorStatus, ila.signals.SwitchStatus)
     */
    @Override
    protected void timeStep(DoorStatus doorStatus, SwitchStatus switchStatus) {
        if (switchStatus != null) {
            currentSwitchState = switchStatus;
        }
        if (doorStatus != null && processedDoorState != doorStatus) {
            processedDoorState = doorStatus;
            
            if (currentSwitchState == DOOR_DEPENDENT) {
                switch (processedDoorState) {
                    case CLOSED:
                        if (!initialized) {
                            initialized = true;
                            sendOnOffRequest(OFF);
                        }
                        else {
                            timer = getFadeOutTime();                            
                        }
                        break;
                    case OPENED:
                        // if timed is active, light is already on.
                        if (timer > 0) {
                            timer = TIMER_INACTIVE;                            
                        }
                        else { // else, we have to emit an on request.
                            sendOnOffRequest(ON);                            
                        }
                        break;
                    default:
                        break;
                }
            }
            initialized = true;
        }
        if (timer == 0) {
            timer = TIMER_INACTIVE;
            sendOnOffRequest(OFF);
        }
        else if (timer > 0) {
            timer--;
        }
    }

    /**
     * @see ila.gen.ADoorEval#setup(sim.IScheduler, sim.error.ISimulationErrorHandler)
     */
    @Override
    public void setup(IScheduler scheduler, ISimulationErrorHandler errorHandler) {
        super.setup(scheduler, errorHandler);
        getOnOffRequest().send(Tick.<OnOffRequest> get());
    }
}
