/*
 * Copyright (c) 2013 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package ila.tryout;

import static ila.signals.OnOffRequest.OFF;
import static ila.signals.OnOffRequest.ON;
import static ila.signals.SwitchStatus.DOOR_DEPENDENT;
import ila.signals.DoorStatus;
import ila.signals.SwitchStatus;
import ila.tryout.gen.ADoorEvalUntimed;

/**
 * A untimed single event version of the DoorEval component.
 * 
 * @author (last commit) $Author: ahaber $
 * @version $Revision: 2580 $, $Date: 2013-10-02 15:44:19 +0000 (Wed, 02 Oct 2013) $
 * @since ILA 1.0.0
 */
public class DoorEvalUntimedImpl extends ADoorEvalUntimed {
    
    private SwitchStatus currentSwitchState;
    
    private DoorStatus processedDoorState;
    
    @Override
    protected void treatDoorStatus(DoorStatus message) {
        if (message != processedDoorState) {
            processedDoorState = message;
            if (currentSwitchState == DOOR_DEPENDENT) {
                switch (message) {
                    case CLOSED:
                        sendOnOffRequest(OFF);
                        break;
                    case OPENED:
                        sendOnOffRequest(ON);
                        break;
                    default:
                        break;
                }
            }
        }
    }
    
    @Override
    protected void treatSwitchStatus(SwitchStatus message) {
        currentSwitchState = message;
    }
}
