package ila;

import ila.signals.*;

/**
 * Evaluates the alarm state of a car received on port {@link alarmStatus}. 
 * Computed result is emitted via port {@link blinkRequest}.
 * If the alarm is active it periodically (periode is {@code blinkIntervall}) 
 * emits ON resp. OFF. If the alarm is inactive, it emits INACTIVE. 
 *
 * @param blinkIntervall amount of time units between alternating ON and OFF, when the alarm is active. 
 * 
 */
component AlarmCheck[int blinkIntervall] {
    
  timing sync;
    
  port
    /** Current alarm status of the car. */
    in AlarmStatus,
    /** Computed blink request. */
    out BlinkRequest; 
}
