package ila;

import ila.signals.*;

/**
* Arbitrates between the received inputs with severity:
* {@link blinkRequest} > {@link onOffRequest} > {@link switchStatus}.
* The most severe signal is used to compute and emit an OnOffCmd
* the is emited via port {@link onOffCmd}.
*/
component ArbiterExt {
    
  timing causalsync;
    
  port
    /** Current status of the interior light switch. */
    in SwitchStatus,
    /** Computed blink request. */
    in BlinkRequest,
    /** Computed on or off request. */
    in OnOffRequest,
    /** Calculated on or off comand. */ 
    out OnOffCmd; 
}
