package ila;

import ila.signals.*;

/**
 * Evaluates the door state received on port {@link doorStatus}, if
 * the switch status received on port {@link switchStatus} is door
 * dependent. The computed request is emitted via port {@link onOffRequest}.
 *
 * @param fadeOutTime fade out time, if door is closed
 */
component DoorEval[int fadeOutTime] {
    
  timing causalsync;
    
  port
    /** State of the doors. */
    in DoorStatus,
    /** State of the light switch. */
    in SwitchStatus,
    /** Computed ON or OFF request. */
    out OnOffRequest; 
}
