//->LightCtrlNoAuto.arc<@ignoreComments
package ila;

import ila.signals.*;

/**
 * Alternative LightCtrl component that does not use 
 * the autoconnect feautre.
*/
component LightCtrlNoAuto {
  
  timing sync;
  
  port 
    /** Current status of the interior light switch. */
    in SwitchStatus,
    /** Current alarm status of the car. */
    in AlarmStatus,
    /** Current state of the car's doors: at least one open or all closed.*/
    in DoorStatus,
    /** Computed command to control the interior light. */
    out OnOffCmd cmd;
  
  component ArbiterExt arbiter;
  component AlarmCheck(5) ac;
  component DoorEval(3);
  
  connect switchStatus -> arbiter.switchStatus,
                          doorEval.switchStatus;
  connect doorStatus -> doorEval.doorStatus;
  connect alarmStatus -> ac.alarmStatus;
  connect doorEval.onOffRequest -> arbiter.onOffRequest;
  connect ac.blinkRequest -> arbiter.blinkRequest;
  connect arbiter.onOffCmd -> cmd;
}
//->LightCtrlNoAuto.arc<