/*
 * Copyright (c) 2013 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package ila.tryout;

import ila.gen.factories.LightCtrlFactory;
import ila.gen.interfaces.ILightCtrl;

/**
 * A {@link LightCtrlFactory} that produces {@link LightCtrlNoAutoAdjustedInterface} 
 * components.
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 2965 $,
 *          $Date: 2014-08-27 15:25:52 +0200 (Mi, 27 Aug 2014) $
 * @since   2.4.0
 *
 */
public class LightCtrlNoAutoCfgAdjustedInterfaceFactory extends LightCtrlFactory {
    
    private LightCtrlNoAutoCfgAdjustedInterfaceFactory() {

    }
    
    public static void intit() {
        LightCtrlFactory.register(new LightCtrlNoAutoCfgAdjustedInterfaceFactory());
    }
    /**
     * @see ila.tryout.gen.factories.LightCtrlAutoFactory#doCreate()
     */
    @Override
    protected ILightCtrl doCreate(int fadeOutTime) {
        return new LightCtrlNoAutoCfgAdjustedInterface(fadeOutTime);
    }
    
}
