package ila;

import ila.signals.*;

testsuite AlarmCheckTest for AlarmCheck(5) {
    
    test initialization {
        input {
            alarmStatus:   <10 * Tk>;
        }
        expect {
            blinkRequest:  <BlinkRequest.INACTIVE, 10 * Tk>;
        }    
    }
    
    test alarmOff {
        input {
            alarmStatus:   <10 * (AlarmStatus.OFF, Tk)>;
        }
        expect {
            blinkRequest:  <BlinkRequest.INACTIVE, 10 * Tk>;
        }    
    }
    
    test alarmOn {
        input {
            alarmStatus:   <21 * (AlarmStatus.ON, Tk)>;
        }
        expect {
            blinkRequest:  <BlinkRequest.INACTIVE, Tk, 2 * (5 * (BlinkRequest.ON, Tk), 5 * (BlinkRequest.OFF, Tk))>;
        }    
    }
    
    test turnOffActiveAlarm {
        input {
            alarmStatus:   <10 * (AlarmStatus.ON, Tk), 11 * (AlarmStatus.OFF, Tk)>;
        }
        expect {
            blinkRequest:  <BlinkRequest.INACTIVE, Tk, 5 * (BlinkRequest.ON, Tk), 4 * (BlinkRequest.OFF, Tk), BlinkRequest.INACTIVE, 11 * Tk>;
        }    
    }

}    