package ila;

import ila.signals.*;

testsuite ArbiterTest for ArbiterExt {
    
    test nothing {
        input {
            // type: ila.signals.SwitchStatus
            switchStatus : <10 * Tk>;
            // type: ila.signals.BlinkRequest
            blinkRequest : <10 * Tk>;
            // type: ila.signals.OnOffRequest
            onOffRequest : <10 * Tk>;
        }
        expect {
            // type: ila.signals.OnOffCmd
            onOffCmd : <Tk, OnOffCmd.OFF, 10 * Tk>;
        }
    }

    test switchStatusOnOnly {
        input {
            switchStatus:   <10 * (SwitchStatus.ON, Tk)>;
            blinkRequest:   <10 * Tk>;
            onOffRequest:   <10 * Tk>;
        }
        expect {
            onOffCmd:      <Tk, OnOffCmd.ON, 10 * Tk>;
        }    
    }
    
    test switchStatusOffOnly {
        input {
            switchStatus:   <10 * (SwitchStatus.OFF, Tk)>;
            blinkRequest:    <10 * Tk>;
            onOffRequest:     <10 * Tk>;
        }
        expect {
            onOffCmd:      <Tk, OnOffCmd.OFF, 10 * Tk>;
        }    
    }
    
    test switchStatusDoorDepOnly {
        input {
            switchStatus:   <10 * (SwitchStatus.DOOR_DEPENDENT, Tk)>;
            blinkRequest:    <10 * Tk>;
            onOffRequest:     <10 * Tk>;
        }
        expect {
            onOffCmd:      <Tk, OnOffCmd.OFF, 10 * Tk>;
        }    
    }
    
    test switchStatusDoorDepDoorOpen {
        input {
            switchStatus:   <10 * (SwitchStatus.DOOR_DEPENDENT, Tk)>;
            blinkRequest:   <10 * Tk>;
            onOffRequest:   <Tk, OnOffRequest.ON, 9 * Tk>;
        }
        expect {
            onOffCmd:       <Tk, OnOffCmd.OFF, Tk, OnOffCmd.ON, 9 * Tk>;
        }    
    }

    test switchStatusDoorDepDoorOpenCloseOpen {
        input {
            switchStatus:   <10 * (SwitchStatus.DOOR_DEPENDENT, Tk)>;
            blinkRequest:   <10 * Tk>;
            onOffRequest:   <Tk, OnOffRequest.ON, 2 * Tk, OnOffRequest.OFF, 2 * Tk, OnOffRequest.ON, 5 * Tk>;
        }
        expect {
            onOffCmd:       <Tk, OnOffCmd.OFF, Tk, OnOffCmd.ON, 2 * Tk, OnOffCmd.OFF, 2 * Tk, OnOffCmd.ON, 5 * Tk>;
        }    
    }

    test switchStatusDoorDepDoorClose {
        input {
            switchStatus:   <10 * (SwitchStatus.DOOR_DEPENDENT, Tk)>;
            blinkRequest:   <10 * Tk>;
            onOffRequest:   <Tk, OnOffRequest.OFF, 9 * Tk>;
        }
        expect {
            onOffCmd:       <Tk, OnOffCmd.OFF, 10 * Tk>;
        }    
    }
    
    test blinkRequestTest {
        input {
            // type: ila.signals.SwitchStatus
            switchStatus : <10 * Tk>;
            // type: ila.signals.BlinkRequest
            blinkRequest : <Tk, 2 * (BlinkRequest.ON, 2 * Tk, BlinkRequest.OFF, 2 * Tk), Tk>;
            // type: ila.signals.OnOffRequest
            onOffRequest : <10 * Tk>;
        }
        expect {
            // type: ila.signals.OnOffCmd
            onOffCmd : <Tk, OnOffCmd.OFF, Tk, 2 * (OnOffCmd.ON, 2 * Tk, OnOffCmd.OFF, 2 * Tk), Tk>;
        }
    }

    test blinkRequestIgnoreSwitchStatus {
        input {
            // type: ila.signals.SwitchStatus
            switchStatus : <5 * (Tk, SwitchStatus.OFF, Tk, SwitchStatus.ON)>;
            // type: ila.signals.BlinkRequest
            blinkRequest : <Tk, 2 * (BlinkRequest.ON, 2 * Tk, BlinkRequest.OFF, 2 * Tk), Tk>;
            // type: ila.signals.OnOffRequest
            onOffRequest : <10 * Tk>;
        }
        expect {
            // type: ila.signals.OnOffCmd
            onOffCmd : <Tk, OnOffCmd.OFF, Tk, 2 * (OnOffCmd.ON, 2 * Tk, OnOffCmd.OFF, 2 * Tk), Tk>;
        }
    }

    test blinkRequestIgnoreOnOffRequest {
        input {
            // type: ila.signals.SwitchStatus
            switchStatus : <10 * Tk>;
            // type: ila.signals.BlinkRequest
            blinkRequest : <Tk, 2 * (BlinkRequest.ON, 2 * Tk, BlinkRequest.OFF, 2 * Tk), Tk>;
            // type: ila.signals.OnOffRequest
            onOffRequest : <5 * (OnOffRequest.ON, Tk, OnOffRequest.OFF, Tk)>;
        }
        expect {
            // type: ila.signals.OnOffCmd
            onOffCmd : <Tk, OnOffCmd.OFF, Tk, 2 * (OnOffCmd.ON, 2 * Tk, OnOffCmd.OFF, 2 * Tk), Tk>;
        }
    }    
}
