package ila;

import ila.signals.*;

testsuite DoorEvalTest for DoorEval(3) { 
    
    test undefinedSwitchStatusDsOn {
        input {
            doorStatus:   <10 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    }
    
    test undefinedSwitchStatusDsOff {
        input {
            doorStatus:   <10 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    }    

    test SsOnDsOn {
        input {
            doorStatus:   <10 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <SwitchStatus.ON, 10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    }
    
    test SsOnDsOff {
        input {
            doorStatus:   <10 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.ON, 10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    }  

    test SsOffDsOn {
        input {
            doorStatus:   <10 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <SwitchStatus.OFF, 10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    }
    
    test SsOffDsOff {
        input {
            doorStatus:   <10 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.OFF, 10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    }    

    test SsDoorDepDsOn {
        input {
            doorStatus:   <10 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <SwitchStatus.DOOR_DEPENDENT, 10 * Tk>;
        }
        expect {
            onOffRequest: <Tk, OnOffRequest.ON, 10 * Tk>;
        }    
    }
    
    test SsDoorDepDsOff {
        input {
            doorStatus:   <10 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.DOOR_DEPENDENT, 10 * Tk>;
        }
        expect {
            onOffRequest: <Tk, OnOffRequest.OFF, 10 * Tk>;
        }    
    }  
    
    test MultiScenarioDoorDep {
        input {
            doorStatus:   <3 * (DoorStatus.CLOSED, Tk), 2 * (DoorStatus.OPENED, Tk), 5 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.DOOR_DEPENDENT, 10 * Tk>;
        }
        expect {
            onOffRequest: <Tk, OnOffRequest.OFF, 3 * Tk, OnOffRequest.ON, 5 * Tk, OnOffRequest.OFF, 2 * Tk>;
        }    
    }

    test MultiScenarioDoorDepCancelFadeOutTimer {
        input {
            doorStatus:   <3 * (DoorStatus.CLOSED, Tk), 2 * (DoorStatus.OPENED, Tk), 2 * (DoorStatus.CLOSED, Tk), 3 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <SwitchStatus.DOOR_DEPENDENT, 10 * Tk>;
        }
        expect {
            onOffRequest: <Tk, OnOffRequest.OFF, 3 * Tk, OnOffRequest.ON, 7 * Tk>;
        }    
    }    
  
    
    test MultiScenarioSsOff {
        input {
            doorStatus:   <3 * (DoorStatus.CLOSED, Tk), 4 * (DoorStatus.OPENED, Tk), 3 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.OFF, 10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    }        
    
    test MultiScenarioSsON {
        input {
            doorStatus:   <3 * (DoorStatus.CLOSED, Tk), 4 * (DoorStatus.OPENED, Tk), 3 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.ON, 10 * Tk>;
        }
        expect {
            onOffRequest: <11 * Tk>;
        }    
    } 
}
