package ila.tryout;

import ila.signals.*;

testsuite DoorEvalUntimedTest for DoorEvalUntimed { 
    
    test undefinedSwitchStatusDsOn {
        input {
            doorStatus:   <10 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    }
    
    test undefinedSwitchStatusDsOff {
        input {
            doorStatus:   <10 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    }    

    test SsOnDsOn {
        input {
            doorStatus:   <10 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <SwitchStatus.ON, 10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    }
    
    test SsOnDsOff {
        input {
            doorStatus:   <10 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.ON, 10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    }  

    test SsOffDsOn {
        input {
            doorStatus:   <10 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <SwitchStatus.OFF, 10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    }
    
    test SsOffDsOff {
        input {
            doorStatus:   <10 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.OFF, 10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    }    

    test SsDoorDepDsOn {
        input {
            doorStatus:   <Tk, 9 * (DoorStatus.OPENED, Tk)>;
            switchStatus: <SwitchStatus.DOOR_DEPENDENT, 10 * Tk>;
        }
        expect {
            onOffRequest: <Tk, OnOffRequest.ON, 9 * Tk>;
        }    
    }
    
    test SsDoorDepDsOff {
        input {
            doorStatus:   <Tk, 9 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.DOOR_DEPENDENT, 10 * Tk>;
        }
        expect {
            onOffRequest: <Tk, OnOffRequest.OFF, 9 * Tk>;
        }    
    }  
    
    test MultiScenarioDoorDep {
        input {
            doorStatus:   <Tk, 3 * (DoorStatus.CLOSED, Tk), 4 * (DoorStatus.OPENED, Tk), 3 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.DOOR_DEPENDENT, 11 * Tk>;
        }
        expect {
            onOffRequest: <Tk, OnOffRequest.OFF, 3 * Tk, OnOffRequest.ON, 4 * Tk, OnOffRequest.OFF, 3 * Tk>;
        }    
    }
    
    test MultiScenarioSsOff {
        input {
            doorStatus:   <3 * (DoorStatus.CLOSED, Tk), 4 * (DoorStatus.OPENED, Tk), 3 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.OFF, 10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    }        
    
    test MultiScenarioSsON {
        input {
            doorStatus:   <3 * (DoorStatus.CLOSED, Tk), 4 * (DoorStatus.OPENED, Tk), 3 * (DoorStatus.CLOSED, Tk)>;
            switchStatus: <SwitchStatus.ON, 10 * Tk>;
        }
        expect {
            onOffRequest: <10 * Tk>;
        }    
    } 
}
